//! @file comparator_drv.h
//!
//! Copyright (c) 2004
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧ق͔rp̒ϸۂƒ`܂݂܂B
//!
//! @version 1.3 (mc100_bldc_sensorless_0_1_0)
//!
//! @todo
//! @bug

#ifndef COMPARATOR_DRV_H
#define COMPARATOR_DRV_H

//_____ ݸٰ _______________________________________________________________

//! @defgroup Comparators_modules r핔
//! r핔
//! @{
//_____ ϸ ___________________________________________________________________

  //! @defgroup Comparators_macros rϸ
  //! i̔r̎gpϸ
  //! @{

	//! @defgroup Comparator0_macros r0ϸ
	//! i̔r0gpϸ
	//! @{

  //! *** r0`Ԑݒ ***
  //! ****** AC0CON
  //! 7		AC0EN		: 1:r틖
  //! 6		AC0IE		: 1:۸ޔr튄荞݋
  //! 5:4	AC0IS1:0	: ۸ޔr튄荞ݑI
  //!					: 00:؂ւ
  //!					: 01:(\)
  //!					: 10:~[
  //!					: 11:㏸[
  //! 3		(\)		: (gp)
  //! 2:0	AC0M2:0		: r0dڼ޽
  //!					: 000:Vref/6.40V
  //!					: 001:Vref/3.20V
  //!					: 010:Vref/2.13V
  //!					: 011:Vref/1.60V
  //!					: 100:۸ޔr픽](ACMPM)
  //!					: 101:D/Aϊo
  //!					: 110:(\)
  //!					: 111:(\)
  //! ****** END AC0CON

	  //! @defgroup Turn_on_comparator0 r0 ON
	  //! r0 ON
	  //! @{
#define Enable_comparator0()					(AC0CON |= (1<<AC0EN) )
	  //! @}

	  //! @defgroup Comparator0_interrupt_enable r0荞݋
	  //! r0荞݋/֎~
	  //! @{
#define Enable_comparator0_interrupt()			(AC0CON |=  (1<<AC0IE) )
#define Disable_comparator0_interrupt()			(AC0CON &= ~(1<<AC0IE) )
	  //! @}

	  //! @defgroup Comparator0_gain_configuration r0荞ݏ`Ԑݒ
	  //! r0̊荞ݏ`Ԑݒ
	  //! @{
//! ؂ւŔr0荞
#define Comparator0_it_on_output_toggle()		(AC0CON &= ~(  (1<<AC0IS1) | (1<<AC0IS0) ) )
//! ~[Ŕr0荞
#define Comparator0_it_on_output_falling_edge()	(AC0CON |=  (1<<AC0IS1), AC0CON &= ~(1<<AC0IS0) )
//! ㏸[Ŕr0荞
#define Comparator0_it_on_output_rising_edge()	(AC0CON |=  ((1<<AC0IS1) | (1<<AC0IS0)) )
	  //! @}

	  //! @defgroup Comparator0_negative_input_selection r0]͑I
	  //! r0̔]͐MIт܂B
	  //! @{
//! r0]͂ƂVref/6.40Vݒ
#define Set_comparator0_ni_vref_6_40()			(AC0CON &= ~( (1<<AC0M2) | (1<<AC0M1) | (1<<AC0M0) ) )
//! r0]͂ƂVref/3.20Vݒ
#define Set_comparator0_ni_vref_3_20()			(AC0CON &= ~( (1<<AC0M2) | (1<<AC0M1) |  (0<<AC0M0) ),\
												 AC0CON |=  ( (0<<AC0M2) | (0<<AC0M1) |  (1<<AC0M0) ) )
//! r0]͂ƂVref/2.13Vݒ
#define Set_comparator0_ni_vref_2_13()			(AC0CON &= ~( (1<<AC0M2) | (0<<AC0M1) |  (1<<AC0M0) ),\
												 AC0CON |=  ( (0<<AC0M2) | (1<<AC0M1) |  (0<<AC0M0) ) ) 
//! r0]͂ƂVref/1.60Vݒ
#define Set_comparator0_ni_vref_1_60()			(AC0CON &= ~( (1<<AC0M2) | (0<<AC0M1) |  (0<<AC0M0) ),	\
												 AC0CON |=  ( (0<<AC0M2) | (1<<AC0M1) |  (1<<AC0M0) ) ) 
//! r0]͂ƂACMPM݂ݒ
#define Set_comparator0_ni_acmp()				(AC0CON &= ~( (0<<AC0M2) | (1<<AC0M1) |  (1<<AC0M0) ),\
												 AC0CON |=  ( (1<<AC0M2) | (0<<AC0M1) |  (0<<AC0M0) ) ) 
//! r0]͂ƂD/Aϊo͂ݒ
#define Set_comparator0_ni_dac()				(AC0CON &= ~( (0<<AC0M2) | (1<<AC0M1) |  (0<<AC0M0) ),\
												 AC0CON |=  ( (1<<AC0M2) | (0<<AC0M1) |  (1<<AC0M0) ) ) 
	  //! @}

	  //! @defgroup Turn_off_comparator0 r0 OFF
	  //! r0 OFF
	  //! @{
#define Disable_comparator0()					(AC0CON &= ~(1<<AC0EN) )
         //! @}
      //! @}

	//! @defgroup Comparator1_macros r1ϸ
	//! i̔r1gpϸ
	//! @{

  //! *** r1`Ԑݒ ***
  //! ****** AC1CON
  //! 7		AC1EN		: 1:r틖
  //! 6		AC1IE		: 1:۸ޔr튄荞݋
  //! 5:4	AC1IS1:0	: ۸ޔr튄荞ݑI
  //!					: 00:؂ւ
  //!					: 01:(\)
  //!					: 10:~[
  //!					: 11;㏸[
  //! 3		(\)		: (gp)
  //! 2:0	AC1M2:0		: r1dڼ޽
  //!					: 000:Vref/6.40V
  //!					: 001:Vref/3.20V
  //!					: 010:Vref/2.13V
  //!					: 011:Vref/1.60V
  //!					: 100:۸ޔr픽](ACMPM)
  //!					: 101:D/Aϊo
  //!					: 110:(\)
  //!					: 111:(\)
  //! ****** END AC1CON

	  //! @defgroup Turn_on_comparator1 r1 ON
	  //! r1 ON
	  //! @{
#define Enable_comparator1()					(AC1CON |= (1<<AC1EN) )
	  //! @}

	  //! @defgroup Comparator1_interrupt_enable r1荞݋
	  //! r1荞݋/֎~
	  //! @{
#define Enable_comparator1_interrupt()			(AC1CON |=  (1<<AC1IE) )
#define Disable_comparator1_interrupt()			(AC1CON &= ~(1<<AC1IE) )
	  //! @}

	  //! @defgroup Comparator1_gain_configuration r1荞ݏ`Ԑݒ
	  //! r1̊荞ݏ`Ԑݒ
	  //! @{
//! ؂ւŔr1荞
#define Comparator1_it_on_output_toggle()		(AC1CON &= ~(  (1<<AC1IS1) | (1<<AC1IS0) ) )
//! ~[Ŕr1荞
#define Comparator1_it_on_output_falling_edge()	(AC1CON |=  (1<<AC1IS1), AC1CON &= ~(1<<AC1IS0) )
//! ㏸[Ŕr1荞
#define Comparator1_it_on_output_rising_edge()	(AC1CON |=  ((1<<AC1IS1) | (1<<AC1IS0)) )
	  //! @}

	  //! @defgroup Comparator1_interrupt_capture r1ߊl荞
	  //! ۸ޔrł/1ߊlۂ̋/֎~
	  //! @{
#define Enable_comparator1_interrupt_capture()	(AC1CON |=  (1<<AC1ICE) )
#define Disable_comparator1_interrupt_capture()	(AC1CON &= ~(1<<AC1ICE) )
	  //! @}

	  //! @defgroup Comparator1_negative_input_selection r1]͑I
	  //! r1̔]͐MIт܂B
	  //! @{
//! r1]͂ƂVref/6.40Vݒ
#define Set_comparator1_ni_vref_6_40()			(AC1CON &= ~( (1<<AC1M2) | (1<<AC1M1) | (1<<AC1M0) ) )
//! r1]͂ƂVref/3.20Vݒ
#define Set_comparator1_ni_vref_3_20()			(AC1CON &= ~( (1<<AC1M2) | (1<<AC1M1) |  (0<<AC1M0) ),\
												 AC1CON |=  ( (0<<AC1M2) | (0<<AC1M1) |  (1<<AC1M0) ) )
//! r1]͂ƂVref/2.13Vݒ
#define Set_comparator1_ni_vref_2_13()			(AC1CON &= ~( (1<<AC1M2) | (0<<AC1M1) |  (1<<AC1M0) ),\
												 AC1CON |=  ( (0<<AC1M2) | (1<<AC1M1) |  (0<<AC1M0) ) )
//! r1]͂ƂVref/1.60Vݒ
#define Set_comparator1_ni_vref_1_60()			(AC1CON &= ~( (1<<AC1M2) | (0<<AC1M1) |  (0<<AC1M0) ),\
												 AC1CON |=  ( (0<<AC1M2) | (1<<AC1M1) |  (1<<AC1M0) ) )
//! r1]͂ƂACMPM݂ݒ
#define Set_comparator1_ni_acmp()				(AC1CON &= ~( (0<<AC1M2) | (1<<AC1M1) |  (1<<AC1M0) ),\
												 AC1CON |=  ( (1<<AC1M2) | (0<<AC1M1) |  (0<<AC1M0) ) )
//! r1]͂ƂD/Aϊo͂ݒ
#define Set_comparator1_ni_dac()				(AC1CON &= ~( (0<<AC1M2) | (1<<AC1M1) |  (0<<AC1M0) ),\
												 AC1CON |=  ( (1<<AC1M2) | (0<<AC1M1) |  (1<<AC1M0) ) )
	  //! @}

	  //! @defgroup Turn_off_comparator1 r1 OFF
	  //! r0 OFF
	  //! @{
#define Disable_comparator1()					(AC1CON &= ~(1<<AC1EN) )
	  //! @}
	//! @}

	//! @defgroup Comparator2_macros r2ϸ
	//! i̔r2gpϸ
	//! @{

  //! *** r2`Ԑݒ ***
  //! ****** AC2CON
  //! 7		AC2EN		: 1:r틖
  //! 6		AC2IE		: 1:۸ޔr튄荞݋
  //! 5:4	AC2IS1:0	: ۸ޔr튄荞ݑI
  //!					: 00:؂ւ
  //!					: 01:(\)
  //!					: 10:~[
  //!					: 11;㏸[
  //! 3		(\)		: (gp)
  //! 2:0	AC2M2:0		: r2dڼ޽
  //!					: 000:Vref/6.40V
  //!					: 001:Vref/3.20V
  //!					: 010:Vref/2.13V
  //!					: 011:Vref/1.60V
  //!					: 100:۸ޔr픽](ACMPM)
  //!					: 101:D/Aϊo
  //!					: 110:(\)
  //!					: 111;(\)
  //! ****** END AC2CON

	  //! @defgroup Turn_on_comparator2 r2 ON
	  //! r2 ON
	  //! @{
#define Enable_comparator2()					(AC2CON |= (1<<AC2EN) )
	  //! @}

	  //! @defgroup Comparator2_interrupt_enable r2荞݋
	  //! r2荞݋/֎~
	  //! @{
#define Enable_comparator2_interrupt()			(AC2CON |=  (1<<AC2IE) )
#define Disable_comparator2_interrupt()			(AC2CON &= ~(1<<AC2IE) )
	  //! @}

	  //! @defgroup Comparator2_gain_configuration r2荞ݏ`Ԑݒ
	  //! r2̊荞ݏ`Ԑݒ
	  //! @{
//! ؂ւŔr2荞
#define Comparator2_it_on_output_toggle()		(AC2CON &= ~(  (1<<AC2IS1) | (1<<AC2IS0) ) )
//! ~[Ŕr2荞
#define Comparator2_it_on_output_falling_edge()	(AC2CON |=  (1<<AC2IS1), AC2CON &= ~(1<<AC2IS0) )
//! ㏸[Ŕr2荞
#define Comparator2_it_on_output_rising_edge()	(AC2CON |=  ((1<<AC2IS1) | (1<<AC2IS0)) )
	  //! @}

	  //! @defgroup Comparator2_negative_input_selection r2]͑I
	  //! r2̔]͐MIт܂B
	  //! @{
//! r2]͂ƂVref/6.40Vݒ
#define Set_comparator2_ni_vref_6_40()			(AC2CON &= ~( (1<<AC2M2) | (1<<AC2M1) | (1<<AC2M0) ) )
//! r2]͂ƂVref/3.20Vݒ
#define Set_comparator2_ni_vref_3_20()			(AC2CON &= ~( (1<<AC2M2) | (1<<AC2M1) |  (0<<AC2M0) ),\
												 AC2CON |=  ( (0<<AC2M2) | (0<<AC2M1) |  (1<<AC2M0) ) )
//! r2]͂ƂVref/2.13Vݒ
#define Set_comparator2_ni_vref_2_13()			(AC2CON &= ~( (1<<AC2M2) | (0<<AC2M1) |  (1<<AC2M0) ),\
												 AC2CON |=  ( (0<<AC2M2) | (1<<AC2M1) |  (0<<AC2M0) ) )
//! r2]͂ƂVref/1.60Vݒ
#define Set_comparator2_ni_vref_1_60()			(AC2CON &= ~( (1<<AC2M2) | (0<<AC2M1) |  (0<<AC2M0) ),\
												 AC2CON |=  ( (0<<AC2M2) | (1<<AC2M1) |  (1<<AC2M0) ) )
//! r2]͂ƂACMPM݂ݒ
#define Set_comparator2_ni_acmp()				(AC2CON &= ~( (0<<AC2M2) | (1<<AC2M1) |  (1<<AC2M0) ),\
												 AC2CON |=  ( (1<<AC2M2) | (0<<AC2M1) |  (0<<AC2M0) ) )
//! r2]͂ƂD/Aϊo͂ݒ
#define Set_comparator2_ni_dac()				(AC2CON &= ~( (0<<AC2M2) | (1<<AC2M1) |  (0<<AC2M0) ),\
												 AC2CON |=  ( (1<<AC2M2) | (0<<AC2M1) |  (1<<AC2M0) ) )
	  //! @}

	  //! @defgroup Turn_off_comparator2 r2 OFF
	  //! r0 OFF
	  //! @{
#define Disable_comparator2()					(AC2CON &= ~(1<<AC2EN) )
	  //! @}
	//! @}
  //! @}

//_____ ` __________________________________________________________________

//_____ ֐ __________________________________________________________________
  //! @defgroup Comparators_low_level_functions rʊ֐
  //! rʊ֐
  //! @{

//! r`Ԑݒl`ɏ]Ĕr`Ԑݒ
//! DIDR0DIDR1ڼ޽ɂı۸ޔr͂۸ޓ͂ƂđIȂ΂
//! ȂƂɒӂĂB
//!

	//! @defgroup Comparator0_low_level_functions r0ʊ֐
	//! r0ʊ֐
	//! @{
void init_comparator0(void);
	//! @}

	//! @defgroup Comparator1_low_level_functions r1ʊ֐
	//! r1ʊ֐
	//! @{
void init_comparator1(void);
	//! @}

	//! @defgroup Comparator2_low_level_functions r2ʊ֐
	//! r2ʊ֐
	//! @{
void init_comparator2(void);
	//! @}
  //! @}
//! @}
#endif  // COMPARATOR_DRV_H
